import java.util.Properties;
import javax.naming.Context;
import javax.naming.InitialContext;

import java.util.Properties;

public class TestClient {
  public static void main(String[] args) {
    try {
      System.out.println("Preparing properties...");
      Properties properties = new Properties();
      properties.put(Context.INITIAL_CONTEXT_FACTORY,
        "org.jnp.interfaces.NamingContextFactory");
      properties.put(Context.URL_PKG_PREFIXES,
        "org.jnp.interfaces");
      properties.put(Context.PROVIDER_URL,
        "127.0.0.1");

      System.out.println("Getting initial context...");
      Context context = new InitialContext(properties);
      System.out.println("Got initial context.");
      if (context != null) {
        System.out.println("Getting the home interface...");
        TestHome testHome = (TestHome)context.lookup("TestEJB");
        if (testHome != null) {
          System.out.println("Getting an EJB...");
          Test test = testHome.create();
          if (test != null) {
            System.out.println("Calling a method...");
            System.out.println(test.sayHello());
          } else {
            System.err.println("Unable to find EJB.");
          }
        } else {
          System.err.println("Unable to find home interface.");
        }
      } else {
        System.err.println("Unable to find obtain initial context.");
      }
    } catch (Exception e) {
      System.err.println("Error!");
      System.err.println(e);
    }
  }
}
