import javax.ejb.*;
import java.rmi.*;
import java.sql.*;
import java.util.*;

public class EJDictionaryBean implements SessionBean {
  private SessionContext mContext = null;

  // Session bean methods
  public void ejbPassivate() {
    System.out.println("EJDictionaryBean passivated.");
  }
  public void ejbActivate() {
    System.out.println("EJDictionaryBean activated.");
  }
  public void ejbCreate() {
    System.out.println("EJDictionaryBean created.");
  }
  public void ejbRemove() {
    System.out.println("EJDictionaryBean removed.");
  }

  // Get session context from container
  public void setSessionContext(SessionContext context) {
    System.out.println("EJDictionaryBean context set.");
    mContext = context;
  }

  // Business methods
  public String[] toJapanese(String english) throws RemoteException {
    System.out.println(english);
    ArrayList    lst = new ArrayList();
    try {
      Class.forName("postgresql.Driver");
      String     url = "jdbc:postgresql:edict";
      Connection conn = DriverManager.getConnection(url, "javaone", "");
      Statement  stmt = conn.createStatement();
      String     qry = "select japanese.kanji, japanese.kana " +
                       "from english, japanese " +
                       "where english = '" + english + "'" +
                       "and english.kanji = japanese.kanji";
      ResultSet  rset = stmt.executeQuery(qry);
      while (rset.next()) {
        String kanji = rset.getString(1) +
          " - " + rset.getString(2);
        System.out.println("  " + kanji);
        lst.add(kanji);
      }
      int matches = lst.size();
      String[] retValue = new String[matches];
      for (int i = 0; i < matches; i++) {
        retValue[i] = (String)lst.get(i);
      }
      return retValue;
    } catch (Exception e) {
      return new String[] {e.toString()};
    }
  }

  // For testing...
  public static void main(String[] args) {
    EJDictionaryBean ejdb = new EJDictionaryBean();
    try {
      String[] japanese = ejdb.toJapanese("car");

      System.out.println("A car is a:");
      for (int i = 0; i < japanese.length; i++) {
        System.out.println("  " + japanese[i]);
      }

    } catch (Exception e) {
      System.err.println("Exception!");
      e.printStackTrace();
    }
  }
}
