import java.util.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.naming.*;

public class e2j extends HttpServlet {

  private void displayInputForm (PrintWriter out) {
    out.println("<form action=e2j method=POST>");
    out.println("Enter an English word to translate:");
    out.println("<input type=text name=english>");
    out.println("</form>");
  }

  private void displayTranslation(PrintWriter out, String english) {
    try {
      // Setting properties...
      Properties properties = new Properties();
      properties.put(Context.INITIAL_CONTEXT_FACTORY,
        "org.jnp.interfaces.NamingContextFactory");
      properties.put(Context.URL_PKG_PREFIXES,
        "org.jnp.interfaces");
      properties.put(Context.PROVIDER_URL,
        "127.0.0.1");

      // Getting initial context...
      Context context = new InitialContext(properties);

      // Getting home interface...
      EJDictionaryHome dictionaryHome =
        (EJDictionaryHome)context.lookup("EJDictionaryServer");

      // Creating remote interface...
      EJDictionary dictionary = dictionaryHome.create();

      // Invoking...
      String[] match = dictionary.toJapanese(english);
      int matchCount = match.length;
      for (int i = 0; i < matchCount; i++) {
        out.println("<p>" + match[i]);
      }
    } catch (Exception e) {
      out.println("<p>Unable to process request!<p>");
      out.println(e);
    }
  }

  public void service (HttpServletRequest request,
    HttpServletResponse response) throws ServletException, IOException {
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.println("<body>");
    out.println("<h3>English to Japanese</h3>");
    String english = request.getParameter("english");
    displayInputForm(out);
    if (english != null) {
      out.println("<h3>" + english + "</h3>");
      displayTranslation(out, english);
    }
    out.println("</body>");
  }
}
